<template>
  <FormBuilder ref="form" v-model="computedValue" :fields="editableFields" />
</template>

<script lang="ts">
import Vue from "vue";
import FormBuilder from "@/components/Form.vue";
export default Vue.extend({
  name: "Test",
  components: {
    FormBuilder
  },
  props: {
    value: {
      type: Object,
      default: () => [{}]
    }
  },
  data() {
    return {
      editableFields: [],
      editemItem: {}
    };
  },
  computed: {
    computedValue: {
      // @ts-ignore
      deep: true,
      get() {
        // @ts-ignore
        return this.value;
      },
      set(v) {
        // @ts-ignore
        this.$emit("input", v);
      }
    }
  },
  methods: {
    // @ts-ignore
    validate() {
      // @ts-ignore
      return this.$refs.form.validate();
    },
    // @ts-ignore
    generateMappingForm(headers) {
      const fields = [
        { id: "id", label: "Order Id", defaultValue: "Id" },
        { id: "driverId", label: "Driver id", defaultValue: "Driver ID" },
        { id: "driverName", label: "Driver name", defaultValue: "Driver name" },
        {
          id: "driverPhone",
          label: "Driver phone number",
          defaultValue: "Driver phone"
        },
        { id: "rating", label: "Driver rating", defaultValue: "Driver rating" },
        {
          id: "date",
          label: "Order Date",
          defaultValue: "Passenger requested and accepted"
        }
      ];
      // @ts-ignore
      this.editableFields = [];
      fields.forEach(field => {
        // @ts-ignore
        this.computedValue[field.id] = field.defaultValue;
        // @ts-ignore
        this.editableFields.push({
          id: field.id,
          type: "v-text-field",
          required: true,
          cols: "6",
          props: {
            outlined: true,
            label: field.label,
            // @ts-ignore
            rules: [v => !!v || `${field.label} is required`],
            items: headers
          }
        });
      });
    }
  }
});
</script>
